Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_configuration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_configuration.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_configuration.cpp	(revision 88)
@@ -0,0 +1,204 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+//   using namespace behavioural::configuration;
+//   using namespace behavioural::custom;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::configuration"
+  void Morpheo::configuration (std::string filename_simulator, 
+                               std::string filename_generator, 
+                               std::string filename_instance ,
+                               behavioural::custom::custom_information_t (*get_custom_information) (void))
+  {
+    log_begin(Morpheo,FUNCTION);
+
+    _config = new behavioural::configuration::Configuration (filename_simulator,
+                                                             filename_generator,
+                                                             filename_instance,
+                                                             get_custom_information);
+    
+    _name             = _config->getName ();
+    _usage            = _config->getUsage();
+
+    // Test usage
+    usage_environment(_usage);
+
+#ifdef STATISTICS
+    _param_statistics = _config->getParamStatistics();
+#endif
+
+    configuration::Parameters * param = _config->getParam();
+
+    _param_core       = new core::Parameters
+      (
+       param->_size_general_data                             ,
+       param->_size_special_data                             ,
+       param->_get_custom_information                        ,
+
+       param->_nb_thread                                     ,
+       param->_size_ifetch_queue                             ,
+       param->_nb_inst_fetch                                 ,
+       param->_implement_group                               ,
+       param->_ras_size_queue                                ,
+       param->_upt_size_queue                                ,
+
+       param->_nb_decod_bloc                                 ,
+       param->_size_decod_queue                              ,
+       param->_nb_inst_decod                                 ,
+       param->_nb_context_select                             ,
+       param->_context_select_priority                       ,
+       param->_context_select_load_balancing                 ,
+
+       param->_nb_rename_bloc                                ,
+       param->_nb_inst_insert                                ,
+       param->_nb_inst_retire                                ,
+       param->_rename_select_priority                        ,
+       param->_rename_select_load_balancing                  ,
+       param->_rename_select_nb_front_end_select             ,
+       param->_nb_general_register                           ,
+       param->_nb_special_register                           ,
+       param->_nb_reg_free                                   ,
+       param->_nb_rename_unit_bank                           ,
+       param->_size_read_counter                             ,
+
+       param->_nb_read_bloc                                  ,
+       param->_size_read_queue                               ,
+       param->_size_reservation_station                      ,
+       param->_nb_inst_retire_reservation_station            ,
+
+       param->_nb_write_bloc                                 ,
+       param->_size_write_queue                              ,
+       param->_size_execute_queue                            ,
+       param->_nb_bypass_write                               ,
+
+       param->_nb_load_store_unit                            ,
+       param->_size_store_queue                              ,
+       param->_size_load_queue                               ,
+       param->_size_speculative_access_queue                 ,
+       param->_nb_port_check                                 ,
+       param->_speculative_load                              ,
+       param->_nb_bypass_memory                              ,
+       param->_nb_cache_port                                 ,
+       param->_nb_inst_memory                                ,
+
+       param->_nb_functionnal_unit                           ,
+       param->_nb_inst_functionnal_unit                      ,
+       param->_timing                                        ,
+
+       param->_nb_icache_port                                ,
+       param->_icache_port_priority                          ,
+       param->_icache_port_load_balancing                    ,
+
+       param->_nb_dcache_port                                ,
+       param->_dcache_port_priority                          ,
+       param->_dcache_port_load_balancing                    ,
+
+       param->_nb_front_end                                  ,
+       param->_nb_context                                    ,
+       param->_nb_decod_unit                                 ,
+       param->_nb_inst_branch_predict                        ,
+       param->_nb_inst_branch_decod                          ,
+       param->_nb_inst_branch_update                         ,
+       param->_btb_size_queue                                ,
+       param->_btb_associativity                             ,
+       param->_btb_size_counter                              ,
+       param->_btb_victim_scheme                             ,
+       param->_dir_predictor_scheme                          ,
+       param->_dir_have_bht                                  ,
+       param->_dir_bht_size_shifter                          ,
+       param->_dir_bht_nb_shifter                            ,
+       param->_dir_have_pht                                  ,
+       param->_dir_pht_size_counter                          ,
+       param->_dir_pht_nb_counter                            ,
+       param->_dir_pht_size_address_share                    ,
+
+       param->_nb_ooo_engine                                 ,
+       param->_nb_rename_unit                                ,
+       param->_nb_inst_issue                                 ,
+       param->_nb_inst_reexecute                             ,
+       param->_nb_inst_commit                                ,
+       param->_nb_inst_branch_complete                       ,
+       param->_nb_rename_unit_select                         ,
+       param->_nb_execute_loop_select                        ,
+       param->_size_re_order_buffer                          ,
+       param->_nb_re_order_buffer_bank                       ,
+       param->_commit_priority                               ,
+       param->_commit_load_balancing                         ,
+       param->_size_issue_queue                              ,
+       param->_nb_issue_queue_bank                           ,
+       param->_issue_priority                                ,
+       param->_issue_load_balancing                          ,
+       param->_size_reexecute_queue                          ,
+       param->_reexecute_priority                            ,
+       param->_reexecute_load_balancing                      ,
+
+       param->_nb_execute_loop                               ,
+       param->_nb_read_unit                                  ,
+       param->_nb_execute_unit                               ,
+       param->_nb_write_unit                                 ,
+       param->_nb_gpr_bank                                   ,
+       param->_nb_gpr_port_read_by_bank                      ,
+       param->_nb_gpr_port_write_by_bank                     ,
+       param->_nb_spr_bank                                   ,
+       param->_nb_spr_port_read_by_bank                      ,
+       param->_nb_spr_port_write_by_bank                     ,
+       param->_execution_unit_to_write_unit_priority         ,
+       param->_read_unit_to_execution_unit_priority          ,
+
+       param->_link_context_with_thread                      ,
+       param->_link_decod_unit_with_decod_bloc               ,
+       param->_link_rename_unit_with_rename_bloc             ,
+       param->_link_read_unit_with_read_bloc                 ,
+       param->_link_write_unit_with_write_bloc               ,
+       param->_link_execute_unit_with_functionnal_unit       ,
+       param->_link_execute_unit_with_load_store_unit        ,
+       param->_link_decod_bloc_with_thread                   ,
+       param->_link_rename_bloc_with_front_end               ,
+       param->_table_dispatch                                ,
+       param->_link_read_bloc_and_load_store_unit            ,
+       param->_link_read_bloc_and_functionnal_unit           ,
+       param->_link_write_bloc_and_load_store_unit           ,
+       param->_link_write_bloc_and_functionnal_unit          ,
+       param->_link_load_store_unit_with_thread              ,
+       param->_link_thread_and_functionnal_unit              ,
+       param->_link_icache_port_with_thread                  ,
+       param->_link_dcache_port_with_load_store_unit         ,
+
+       param->_dispatch_priority                             ,
+       param->_dispatch_load_balancing                       );
+
+    // interface parameters
+    _nb_thread                  = _param_core->_nb_thread                 ;
+    _nb_icache_port             = _param_core->_nb_icache_port            ;
+    _size_icache_thread_id      = _param_core->_size_icache_thread_id     ;
+    _size_icache_packet_id      = _param_core->_size_icache_packet_id     ;
+    _size_icache_address        = _param_core->_size_icache_address       ;
+    _size_icache_type           = _param_core->_size_icache_type          ;
+    _size_icache_error          = _param_core->_size_icache_error         ;
+    _icache_nb_instruction      = _param_core->_icache_nb_instruction     ;
+    _size_icache_instruction    = _param_core->_size_instruction          ;
+    _nb_dcache_port             = _param_core->_nb_dcache_port            ;
+    _size_dcache_thread_id      = _param_core->_size_dcache_thread_id     ;
+    _size_dcache_packet_id      = _param_core->_size_dcache_packet_id     ;
+    _size_dcache_address        = _param_core->_size_dcache_address       ;
+    _size_dcache_data           = _param_core->_size_dcache_data          ;
+    _size_dcache_type           = _param_core->_size_dcache_type          ;
+    _size_dcache_error          = _param_core->_size_dcache_error         ;
+    _have_port_icache_thread_id = _param_core->_have_port_icache_thread_id;
+    _have_port_icache_packet_id = _param_core->_have_port_icache_packet_id;
+    _have_port_dcache_thread_id = _param_core->_have_port_dcache_thread_id;
+    _have_port_dcache_packet_id = _param_core->_have_port_dcache_packet_id;
+
+    log_end(Morpheo,FUNCTION);
+  };
+}; // end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_deallocation.cpp	(revision 88)
@@ -0,0 +1,65 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+#include "Behavioural/include/Allocation.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::deallocation"
+  void Morpheo::deallocation (void)
+  {
+    log_begin(Morpheo,FUNCTION);
+
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+	delete    in_CLOCK ;
+	delete    in_NRESET;
+
+        DELETE1_SIGNAL(out_ICACHE_REQ_VAL         ,_param_core->_nb_icache_port,1);
+        DELETE1_SIGNAL( in_ICACHE_REQ_ACK         ,_param_core->_nb_icache_port,1);
+        DELETE1_SIGNAL(out_ICACHE_REQ_THREAD_ID   ,_param_core->_nb_icache_port,_param_core->_size_icache_thread_id);
+        DELETE1_SIGNAL(out_ICACHE_REQ_PACKET_ID   ,_param_core->_nb_icache_port,_param_core->_size_icache_packet_id);
+        DELETE1_SIGNAL(out_ICACHE_REQ_ADDRESS     ,_param_core->_nb_icache_port,_param_core->_size_icache_address);
+        DELETE1_SIGNAL(out_ICACHE_REQ_TYPE        ,_param_core->_nb_icache_port,_param_core->_size_icache_type);
+  
+        DELETE1_SIGNAL( in_ICACHE_RSP_VAL         ,_param_core->_nb_icache_port,1);
+        DELETE1_SIGNAL(out_ICACHE_RSP_ACK         ,_param_core->_nb_icache_port,1);
+        DELETE1_SIGNAL( in_ICACHE_RSP_THREAD_ID   ,_param_core->_nb_icache_port,_param_core->_size_icache_thread_id);
+        DELETE1_SIGNAL( in_ICACHE_RSP_PACKET_ID   ,_param_core->_nb_icache_port,_param_core->_size_icache_packet_id);
+        DELETE1_SIGNAL( in_ICACHE_RSP_ERROR       ,_param_core->_nb_icache_port,_param_core->_size_icache_error);
+        DELETE2_SIGNAL( in_ICACHE_RSP_INSTRUCTION ,_param_core->_nb_icache_port,_param_core->_icache_nb_instruction[it1],_param_core->_size_instruction);
+  
+        DELETE1_SIGNAL(out_DCACHE_REQ_VAL         ,_param_core->_nb_dcache_port,1);
+        DELETE1_SIGNAL( in_DCACHE_REQ_ACK         ,_param_core->_nb_dcache_port,1);
+        DELETE1_SIGNAL(out_DCACHE_REQ_THREAD_ID   ,_param_core->_nb_dcache_port,_param_core->_size_dcache_thread_id);
+        DELETE1_SIGNAL(out_DCACHE_REQ_PACKET_ID   ,_param_core->_nb_dcache_port,_param_core->_size_dcache_packet_id);
+        DELETE1_SIGNAL(out_DCACHE_REQ_ADDRESS     ,_param_core->_nb_dcache_port,_param_core->_size_dcache_address);
+        DELETE1_SIGNAL(out_DCACHE_REQ_WDATA       ,_param_core->_nb_dcache_port,_param_core->_size_dcache_data);
+        DELETE1_SIGNAL(out_DCACHE_REQ_TYPE        ,_param_core->_nb_dcache_port,_param_core->_size_dcache_type);
+  
+        DELETE1_SIGNAL( in_DCACHE_RSP_VAL         ,_param_core->_nb_dcache_port,1);
+        DELETE1_SIGNAL(out_DCACHE_RSP_ACK         ,_param_core->_nb_dcache_port,1);
+        DELETE1_SIGNAL( in_DCACHE_RSP_THREAD_ID   ,_param_core->_nb_dcache_port,_param_core->_size_dcache_thread_id);
+        DELETE1_SIGNAL( in_DCACHE_RSP_PACKET_ID   ,_param_core->_nb_dcache_port,_param_core->_size_dcache_packet_id);
+        DELETE1_SIGNAL( in_DCACHE_RSP_RDATA       ,_param_core->_nb_dcache_port,_param_core->_size_dcache_data);
+        DELETE1_SIGNAL( in_DCACHE_RSP_ERROR       ,_param_core->_nb_dcache_port,_param_core->_size_dcache_error);
+  
+        DELETE1_SIGNAL( in_INTERRUPT_ENABLE       ,_param_core->_nb_thread,1);
+      }
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    delete _component;
+    delete _component_core;
+
+    log_end(Morpheo,FUNCTION);
+  };
+
+}; // end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_end_cycle.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_end_cycle.cpp	(revision 88)
@@ -0,0 +1,37 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::end_cycle"
+void Morpheo::end_cycle ()
+  {
+    log_begin(Morpheo,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
+#endif
+
+    log_end(Morpheo,FUNCTION);
+  };
+
+}; // end namespace morpheo
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_header.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_header.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_header.cpp	(revision 88)
@@ -0,0 +1,66 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+#include "Behavioural/include/Version.h"
+
+namespace morpheo {
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::header"
+  std::string Morpheo::header (void)
+  {
+    log_begin(Morpheo,FUNCTION);
+
+    std::string str = "";
+
+    /*
+                             _                
+                            | |               
+  _ __ ___   ___  _ __ _ __ | |__   ___  ___  
+ | '_ ` _ \ / _ \| '__| '_ \| '_ \ / _ \/ _ \ 
+ | | | | | | (_) | |  | |_) | | | |  __/ (_) |
+ |_| |_| |_|\___/|_|  | .__/|_| |_|\___|\___/ 
+                      | |                     
+                      |_|                     
+                                  __                       
+                                 /\ \                      
+   ___ ___     ___   _ __   _____\ \ \___      __    ___   
+ /' __` __`\  / __`\/\`'__\/\ '__`\ \  _ `\  /'__`\ / __`\ 
+ /\ \/\ \/\ \/\ \L\ \ \ \/ \ \ \L\ \ \ \ \ \/\  __//\ \L\ \
+ \ \_\ \_\ \_\ \____/\ \_\  \ \ ,__/\ \_\ \_\ \____\ \____/
+  \/_/\/_/\/_/\/___/  \/_/   \ \ \/  \/_/\/_/\/____/\/___/ 
+                              \ \_\                        
+                               \/_/                        
+
+*/
+
+    str += toString(MSG_INFORMATION)+"                                  __                       \n";
+    str += toString(MSG_INFORMATION)+"                                 /\\ \\                      \n";
+    str += toString(MSG_INFORMATION)+"   ___ ___     ___   _ __   _____\\ \\ \\___      __    ___   \n";
+    str += toString(MSG_INFORMATION)+" /' __` __`\\  / __`\\/\\`'__\\/\\ '__`\\ \\  _ `\\  /'__`\\ / __`\\ \n";
+    str += toString(MSG_INFORMATION)+" /\\ \\/\\ \\/\\ \\/\\ \\L\\ \\ \\ \\/ \\ \\ \\L\\ \\ \\ \\ \\ \\/\\  __//\\ \\L\\ \\\n";
+    str += toString(MSG_INFORMATION)+" \\ \\_\\ \\_\\ \\_\\ \\____/\\ \\_\\  \\ \\ ,__/\\ \\_\\ \\_\\ \\____\\ \\____/\n";
+    str += toString(MSG_INFORMATION)+"  \\/_/\\/_/\\/_/\\/___/  \\/_/   \\ \\ \\/  \\/_/\\/_/\\/____/\\/___/ \n";
+    str += toString(MSG_INFORMATION)+"                              \\ \\_\\                        \n";
+    str += toString(MSG_INFORMATION)+"                               \\/_/                        \n";
+    str += toString(MSG_INFORMATION)+"\n";
+    str += toString(MSG_INFORMATION)+_("  * Multiple ORganization of a Processor with HEterogeneous and Open architecture\n");
+    str += toString(MSG_INFORMATION)+_("  * Version            : ")+toString(MORPHEO_HEADER)+"\n";
+    str += toString(MSG_INFORMATION)+_("  * Last change        : ")+toString(MORPHEO_DATE  )+"\n";
+    str += toString(MSG_INFORMATION)+_("  * E-mail support     : mathieu.rosiere@lip6.fr\n"      );
+    str += toString(MSG_INFORMATION)+_("  * Original author(s) : Mathieu  Rosière\n"             );
+    str += toString(MSG_INFORMATION)+_("  * Contributor(s)     : Stéphane Dubuisson - XMLLight\n");
+    str += toString(MSG_INFORMATION)+_("                         Vincent  Moulu     - VHDL\n"    );
+    str += toString(MSG_INFORMATION)+"\n";
+
+    log_end(Morpheo,FUNCTION);
+
+    return str;
+  };
+
+}; // end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_simulation_end.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_simulation_end.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_simulation_end.cpp	(revision 88)
@@ -0,0 +1,24 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+#include "Behavioural/include/Simulation.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::simulation_end"
+  bool Morpheo::simulation_end (void)
+  {
+    return simulation_test_end();
+  };
+
+}; // end namespace morpheo
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,31 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::statistics_allocation"
+  void Morpheo::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(Morpheo,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Morpheo",
+		      param_statistics);
+
+    _stat->add_stat(_component_core->_stat);
+    
+    log_end(Morpheo,FUNCTION);
+  };
+
+}; // end namespace morpheo
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,29 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::statistics_deallocation"
+  void Morpheo::statistics_deallocation (void)
+  {
+    log_begin(Morpheo,FUNCTION);
+
+    log_printf(INFO,Morpheo,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+    
+    delete _stat;
+    
+    log_end(Morpheo,FUNCTION);
+  };
+
+}; // end namespace morpheo
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_transition.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_transition.cpp	(revision 88)
@@ -0,0 +1,36 @@
+# if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+#include "Behavioural/include/Simulation.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::transition"
+  void Morpheo::transition (void)
+  {
+    log_begin(Morpheo,FUNCTION);
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    // Test stop condition
+    if (simulation_test_end())
+      sc_stop();
+
+    log_end(Morpheo,FUNCTION);
+  };
+
+}; // end namespace morpheo
+# endif
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_vhdl.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/TopLevel/src/Morpheo_vhdl.cpp	(revision 88)
@@ -0,0 +1,35 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "TopLevel/include/Morpheo.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo {
+
+  using namespace behavioural;
+
+#undef  FUNCTION
+#define FUNCTION "Morpheo::vhdl"
+  void Morpheo::vhdl (void)
+  {
+    log_begin(Morpheo,FUNCTION);
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_end(Morpheo,FUNCTION);
+  };
+
+}; // end namespace morpheo
+#endif
Index: /trunk/IPs/systemC/shared/soclib_segment_table.h
===================================================================
--- /trunk/IPs/systemC/shared/soclib_segment_table.h	(revision 87)
+++ /trunk/IPs/systemC/shared/soclib_segment_table.h	(revision 88)
@@ -122,5 +122,5 @@
 	{ 
 	printf("segment : %s , base = %.8x , size = %.8x , Global target = %d , Local Target = %d , unc = %d, addr_alloc : %.8x\n",
-	       name, base, size, globalTarget, localTarget, uncached, (unsigned int) addr_alloc);
+	       name, base, size, globalTarget, localTarget, uncached, (unsigned int)((long long)addr_alloc));
 	};
 
@@ -295,5 +295,5 @@
 	  {
 	    unsigned int offset = (addr-addr_min);
-	    return (void*)((unsigned int)(*segIterator).getAddrAlloc() + offset);
+	    return (void*)((unsigned int)(long long)((*segIterator).getAddrAlloc()) + offset);
 	  }
       }
Index: /trunk/Makefile.flags
===================================================================
--- /trunk/Makefile.flags	(revision 88)
+++ /trunk/Makefile.flags	(revision 88)
@@ -0,0 +1,46 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+
+#-----[ Simulator ]----------------------------------------
+SIMULATOR			= systemcass
+
+# 3 simulators :
+# systemc			- SystemC    
+# systemcass 			- SystemCASS
+# systemcass_deps		- Systemcass, and use port dependency information instead of sensitivity list
+
+#-----[ Flags ]--------------------------------------------
+MORPHEO_FLAGS			=	-DSYSTEMC		\
+					-DDEBUG=DEBUG_TRACE     \
+					-DSTATISTICS 		\
+					-DVHDL			\
+  					-DVHDL_TESTBENCH	\
+					-DVHDL_TESTBENCH_ASSERT	\
+					-DTRANSLATION 	        
+
+#					-DPRINT_COLOR        	\
+#					-DLOG_FILE      	\
+#					-DPOSITION       	\
+#					-DREGISTER_INIT         \
+
+# Flags :
+# DEBUG={level}                               - Print Debug Message
+# LOG_FILE                                    - Print Message in a log file
+# SYSTEMC                                     - To generate a systemc's model
+# VHDL                                        - To generate a vhdl's    models
+# VHDL_TESTBENCH        (need SYSTEMC)        - In the simulation, generate two testbench's file (input and ouput) to validate the vhdl's model
+# VHDL_TESTBENCH_ASSERT (need VHDL_TESTBENCH) - In the simulation, generate in  testbench's file an serie of assert
+# POSITION                                    - To generate a position's files     (it's input of viewer)
+# STATISTICS            (need SYSTEMC)        - In the simulation, generate a statistics's file
+# INFORMATION           (need STATISTICS)     - Instance Information :
+#                                                 * Static    : at the instance creation
+#                                                    * register number
+#                                                    * worst way
+#                                                 * Dynamique : at the runtime
+#                                                    * consomation
+# TRANSLATION	                              - Translate message
+# REGISTER_INIT				      - Init a lot of register
+# PRINT_COLOR                                 - Print with colors
Index: /trunk/Makefile.tools
===================================================================
--- /trunk/Makefile.tools	(revision 87)
+++ /trunk/Makefile.tools	(revision 88)
@@ -1,2 +1,10 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile tools
+# 
+
 #----------------------------------------------------------
 #-----[ Unix Commands ]------------------------------------
@@ -6,4 +14,5 @@
 
 ECHO					= echo
+PRINTF					= printf
 MKDIR					= mkdir -p
 TEST					= test
@@ -20,25 +29,28 @@
 RANLIB					= ranlib
 BASENAME				= basename
+DIRNAME				        = dirname
 GREP					= grep
 GREP_NOT				= egrep -v
 TR					= tr
 UPPERtoLOWER				= $(TR) [:lower:] [:upper:]
+MSGFMT                                  = msgfmt
 DISTCC					= distcc
-CC_FLAGS_COMMON				= -O3	 	 \
+CC_FLAGS_COMMON				= -O0	 	 \
 					  -g3		 \
 					  -Wall		 \
-					  -Wunused	 \
-					  -m32
+					  -Wunused       \
+                                          -m32
 DIST_CXX				= export LANG=C; $(DISTCC) g++
-SEQ_CXX					= export LANG=C;            g++
+SEQ_CXX					= export LANG=C;           g++
 CXX					= $(DIST_CXX)
 CXX_FLAGS				= $(CC_FLAGS_COMMON)
 DIST_CC					= export LANG=C; $(DISTCC) gcc
-SEQ_CC					= export LANG=C;            gcc
+SEQ_CC					= export LANG=C;           gcc
 CC					= $(DIST_CC)
 CC_FLAGS				= $(CC_FLAGS_COMMON)
 SED					= sed
 TOUCH					= touch
-VALGRIND				= valgrind --tool=memcheck --leak-check=yes --show-reachable=yes --leak-resolution=high
+#VALGRIND				= valgrind --tool=memcheck --leak-check=yes --show-reachable=yes --leak-resolution=high
+VALGRIND				= valgrind --tool=memcheck
 # Commands to generate all documents
 FIG2EPS					= fig2dev -L eps
@@ -50,4 +62,5 @@
 PS2PDF					= ps2pdf
 GNUPLOT					= gnuplot
+DOT					= dot
 # Commands to view the document
 VIEWDVI					= evince
@@ -60,5 +73,9 @@
 #----------------------------------------------------------
 
-include $(MORPHEO_TOPLEVEL)/Makefile.tools_path
+ifeq ($(origin MORPHEO_TOPLEVEL), undefined)
+	$(error "variable MORPHEO_TOPLEVEL is undefined");
+else
+	include $(MORPHEO_TOPLEVEL)/Makefile.tools_path
+endif
 
 #-----[ systemc ]------------------------------------------
Index: /trunk/Makefile.tools_path
===================================================================
--- /trunk/Makefile.tools_path	(revision 87)
+++ /trunk/Makefile.tools_path	(revision 88)
@@ -1,27 +1,36 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile path's tools
+# 
+
 #----------------------------------------------------------
-# kane@HOME
+# HOME
+#-----[ path ]---------------------------------------------
+#ENV					= export PATH=$$PATH:/bin:/usr/bin
+#SYSTEMC_systemc			= /home/data/Tools/systemc-2.2.0
+#SYSTEMC_systemcass 			= /home/data/Tools/systemcass
+#SYSTEMC_systemcass_deps 		= $(SYSTEMC_systemcass)
+#XILINX					= /home/data/Tools/Xilinx91i
+#MODELTECH				= /home/data/Tools/modelsim/modeltech-6.2b
+#MODELTECH_LICENCE			= /home/data/Tools/modelsim/license/license_modelsim-SE-6.2b
+#OR1K					= /home/data/Tools/or32-elf
+#NEWLIB					= 
+#QT					= 
+
+#----------------------------------------------------------
+# LABS
 #-----[ path ]---------------------------------------------
 ENV					= export PATH=$$PATH:/bin:/usr/bin
-SYSTEMC_systemc				= /home/data/Tools/systemc-2.2.0
-SYSTEMC_systemcass 			= /home/data/Tools/systemcass
+SYSTEMC_systemc				= /users/outil/systemc/systemc-2.1.v1
+SYSTEMC_systemcass 			= /users/outil/systemc/systemcass/systemcass/latest/i686-Linux.SLA4x
 SYSTEMC_systemcass_deps 		= $(SYSTEMC_systemcass)
-XILINX					= /home/data/Tools/Xilinx91i
-MODELTECH				= /home/data/Tools/modelsim/modeltech-6.2b
-MODELTECH_LICENCE			= /home/data/Tools/modelsim/license/license_modelsim-SE-6.2b
-OR1K					= /home/data/Tools/or32-elf
+XILINX					= /dsk/l1/misc/Xilinx91i
+MODELTECH				= /users/outil/m1archi/modeltech
+#MODELTECH_LICENCE			= /users/soft/mentor/mgls_v8-1_0-3-1.ss5/etc/cust/mgc/license.anacad.20070720
+MODELTECH_LICENCE			= /users/soft/mentor/mgls_v8-5_0-5-0.ss5/etc/cust/mgc/license.anacad.2008
+OR1K					= /users/cao/kane/Softwares/or32-elf
 NEWLIB					= 
-QT					= 
-
-#----------------------------------------------------------
-# kane@LABS
-#-----[ path ]---------------------------------------------
-#ENV					= export PATH=$$PATH:/bin:/usr/bin
-#SYSTEMC_systemc			= /users/outil/systemc/systemc-2.1.v1				    
-#SYSTEMC_systemcass 			= /users/outil/systemc/systemcass/systemcass/latest/i686-Linux.SLA4x
-#SYSTEMC_systemcass_deps 		= $(SYSTEMC_systemcass)
-#XILINX					= /dsk/l1/misc/Xilinx91i
-#MODELTECH				= /users/outil/m1archi/modeltech
-#MODELTECH_LICENCE			= /users/soft/mentor/mgls_v8-1_0-3-1.ss5/etc/cust/mgc/license.anacad.20070720
-#OR1K					= 
-#NEWLIB					= 
-#QT					= /dsk/l1/misc/kane/qt-x11-opensource-4.2.3
+QT					= /dsk/l1/misc/kane/qt-x11-opensource-4.2.3
